Camera = Entity:extend()
local finalZoom = nil
local targetZoom = 0
local effectiveSpeed = 0
local xOffset = 0
local yOffset = -100


local storedOffsetX
local storedOffsetY

function Camera:new(x, y, zoom, targetZoom)
  Entity.super.new(self, x, y)
  self.maxZoom = 2.5
  finalZoom = self.maxZoom
  self.zoom = self.maxZoom * love.graphics.getHeight()/1080
  self.type = "camera"
--  self.targetZoom = targetZoom*love.graphics.getHeight()/1080
  self.zoomSpeed = 0
  self.shaking = 0
  self.shakeOffset = Vec2(0,0)

  --table.insert(drawTable, self)
end

function Camera:update(dt)

  local xk = window.width/1920 * 450
  local yk = window.height/1080 * 300

  --Eh, can't be bothered up update the variable names

  local mouseX
  local mouseY
  
  if gamepadMode then
    
    if player1.flightMode == "swooping" then
      
      local speedMult = math.min(vector.getMagnitude(velocityVector)*0.0005, 1)
      local velDir = vector.normalize(velocityVector) * speedMult
      
      mouseX = velDir.x * 300
      mouseY = velDir.y * 300
    else
      local joystick = joysticks[1]
      mouseX = joystick:getGamepadAxis("rightx") * xk
      mouseY = joystick:getGamepadAxis("righty") * yk
    end
  else
    mouseX = mouse.x*0.4
    mouseY = mouse.y*0.4
  end
  
  

  local playerSpeed = nil

  if not player1.stasis then
    storedOffsetX = nil
    storedOffsetY = nil

    playerSpeed = vector.getMagnitude(velocityVector)


    effectiveSpeed = moveToward(effectiveSpeed, playerSpeed, math.abs(effectiveSpeed - playerSpeed), dt)


    local reactionTime = 0.5
    local distance = (effectiveSpeed)*reactionTime

    if self.targetZoom then  
      targetZoom = self.targetZoom
      --I'm sorry this is janky but this is the easiest way to do this without changing things
    else
      targetZoom =  math.min(window.height/2/distance, self.maxZoom)
    end
    
    
    local speed = math.abs(targetZoom - finalZoom)
    if finalZoom < targetZoom then
      if math.abs(finalZoom * (1+dt*speed) - targetZoom) < 0.001 then
        finalZoom = targetZoom
      else
        finalZoom = finalZoom * (1+dt*speed)
      end
    elseif finalZoom > targetZoom then
      if math.abs(finalZoom * (1-dt*speed) - targetZoom) < 0.001 then
        finalZoom = targetZoom
      end
      finalZoom = finalZoom * (1-dt*speed) --- dt*speed*finalZoom
    end


    if not builderMode then
      
      self:shakeBehaviour(dt)
      
      local walkOffset = 0
      if player1:canWalk() then
        walkOffset = 100
      end

      self.zoom = finalZoom * window.height/1080

      if not self.targetPoint then

        xOffset = moveToward(xOffset, mouseX, math.abs(mouseX - xOffset), dt) 
        yOffset = moveToward(yOffset, mouseY-walkOffset, math.abs(mouseY-walkOffset - yOffset), dt)

        
        self.x, self.y = player1.body:getPosition()

        self.x = (self.x + xOffset/self.zoom * window.height/1080) * -1 + self.shakeOffset.x
        self.y = (self.y + yOffset/self.zoom * window.height/1080) * -1 + self.shakeOffset.y
      else

        self.x = moveToward(self.x, -self.targetPoint.x, math.abs(self.x + self.targetPoint.x)*2, dt) 
        self.y = moveToward(self.y, -self.targetPoint.y, math.abs(self.y + self.targetPoint.y)*2, dt)
        --Keep the offset updated so that when the dialogue ends, the camera moves back smoothly
        xOffset = (-self.x - player1.body:getX()) * self.zoom
        yOffset = (-self.y - player1.body:getY()) * self.zoom

      end
    end
  else

    
    
    
    
    self.x = -player1.body:getX() + storedOffsetX 
    self.y = -player1.body:getY() + storedOffsetY 

  end
end



function Camera:shake(shakeVector, amount)
  self.shaking = 1
  self.shakeVector = copyTable(shakeVector)
end


function Camera:shakeBehaviour(dt)
  
  if self.shaking > 0 then
    self.shakeOffset.x = self.shakeOffset.x + dt*100
    self.shakeOffset.y = self.shakeOffset.y + dt*100
  end
  
  self.shaking = self.shaking - dt
  
end



function Camera:draw()
  love.graphics.setColor(1,1,1)

  blue.graphics.circle("fill", player1.body:getX(), player1.body:getY(), 10)

  blue.graphics.circle("line", -self.x, -self.y, 11)

  local proposedZoom = 1/2
  love.graphics.setColor(1,1,1)
  blue.graphics.rectangle("line", camera.x*-1 - window.width/2/finalZoom + xOffset, camera.y*-1 - window.height/2/finalZoom + yOffset,  window.width/finalZoom, window.height/finalZoom)


  love.graphics.setColor(0,1,0)
  blue.graphics.rectangle("line", camera.x*-1 - window.width/2/targetZoom + xOffset, camera.y*-1 - window.height/2/targetZoom + yOffset,  window.width/targetZoom, window.height/targetZoom)

--  blue.graphics.circle("line", player1.body:getX(), player1.body:getY(), distance)

end


function moveToward(number, target, speed, dt)

  if speed < 2 then
    speed = 2
  end

  if math.abs(number - target) < speed*dt then
    return target
  elseif number < target then
    return number + dt*speed
  else 
    return number - dt*speed
  end

end