Fireball = Projectile:extend()

lightsFire = {}

function Fireball:new(x, y, vx, vy)
  Fireball.super.new(self, x, y, vx, vy)
  self.type = "fireball"
  --self.body:setLinearDamping(1)
  self.body:setMass(0.25)
  self.fixture:setUserData(self)
  self.life = 2
  self.sparkCountdown = 0
  self.setsFire = true
  table.insert(lightsFire, self)
end


function Fireball:update(dt)
  
  if not self.body:isDestroyed() then
    
    
    if not effectedByTimeBubble(self) then
      self.life = self.life - dt
      
      self.sparkCountdown = self.sparkCountdown - dt
      
      if self.life > 0 and not self.collided then
        if self.sparkCountdown <= 0 then
          local vx, vy = self.body:getLinearVelocity()
          Spark(self.body:getX(),self.body:getY(), 1, vx + love.math.random(-100, 99) + love.math.random(), vy + love.math.random(-100, 99) + love.math.random())
          self.sparkCountdown = self.sparkCountdown + 1/60
        end
      else
        
        local vx, vy = self.body:getLinearVelocity()
        for i = 1, 25 do
          Spark(self.body:getX(),self.body:getY(), 0.5 + love.math.random()*2, vx + love.math.random(-100, 99) + love.math.random(), vy + love.math.random(-300, 299) + love.math.random(), 0)
        end
        self:destroy()
        
      end
    end
    
    
    
  end
end


function Fireball:destroy()
  self.remove = true
  self.body:destroy()
  
  
  for i, v in ipairs(lightsFire) do
    if v == self then
      table.remove(lightsFire, i)
      break
    end
  end
end


function Fireball:draw()
  if not self.body:isDestroyed() then
    love.graphics.setColor(1, 1, 1)
    
    local rot = vector.getOrientation(vector.create(self.body:getLinearVelocity())) + math.rad(90)
    
    if rot ~= rot then
      rot = 0
    end
    addLight(self.body:getX(), self.body:getY(), -5, 1, {1,0.5,0.2})
    blue.graphics.drawCentredShaded(texture.fireball, self.body:getX(), self.body:getY(), rot)
  end
end