FlowLevelPolygon = LevelPolygon:extend()



--Class for level polygons

function FlowLevelPolygon:new(rpm, parent, inputPoints, attributes, pixpol)
  
  FlowLevelPolygon.super.new(self, nil, nil, inputPoints, attributes, pixpol)
  self.body:setType("kinematic")
  self.body:setFixedRotation(false)
  self.body:setMass(1)
  self.type = "flowLevelPolygon"
  
  self.parent = parent
  
  self.x = parent.x
  self.y = parent.y
  self.body:setPosition(self.x, self.y)
  
  self.rotationSpeed = (rpm * 2 * math.pi)/60
  
end



function FlowLevelPolygon:update(dt)
  self.x = self.parent.x
  self.y = self.parent.y
  self.body:setAngularVelocity(self.rotationSpeed)
  self.body:setPosition(self.x, self.y)
  self.body:setLinearVelocity(0,0)
  
  
  
  
  if self.parent.remove then
    self:deletePolygon()
  end
  
end