Brazier = Interactable:extend()

-- Does this class even do anything? Been too long since I looked at this....


function Brazier:new(x, y, attributes)
  Brazier.super.new(self, x, y, attributes)
  self.type = "brazier"
  
  self.attributes.singleUse = nil
  createAttribute(self.attributes, "startsLit", false) 
  createAttribute(self.attributes, "litTriggerTarget", "")
  createAttribute(self.attributes, "extinguishTimer", 0)
  createAttribute(self.attributes, "triggerOnExtinguish", false)
  
  self.attributes.litTexture = nil
  self.attributes.unlitTexture = nil
  
  
  
  if self.attributes.startsLit then
    self:light(true)
  else
    self:extingish(true)
  end
  
  self.lightZoneHeight = 30*smallTextureScale
  self.lightZoneWidth  = 30*smallTextureScale
  
  if texture.brazier_lit.main then
    self.width  = texture.brazier:getWidth() *smallTextureScale*self.attributes.scaleX
    self.height = texture.brazier:getHeight()*smallTextureScale*self.attributes.scaleY
  else
    self.width  = texture.brazier:getWidth() *smallTextureScale*self.attributes.scaleX
    self.height = texture.brazier:getHeight()*smallTextureScale*self.attributes.scaleY
  end
  
end


function Brazier:light(doNotTrigger)
  
  --Return true if not already lit, return false if so
  if self.lit then 
    return false
  else
    self.lit = true
    self.active = true
    self:setDrawMode("animation")
    self.extinguishTimer = self.attributes.extinguishTimer
    
    if not doNotTrigger then
      for i, target in ipairs(nameIndex:getEntities(self.attributes.litTriggerTarget)) do
        if target.activate then
          target:activate(nil, 1)
        end
      end
    end
    return true
  end

  

end


function Brazier:extingish(doNotTrigger)
  local oldLit = self.lit
  self.lit = false
  self.active = false
  self.extinguishTimer = 0
  self:setDrawMode("texture")

  if (not doNotTrigger) then
    if self.attributes.triggerOnExtinguish then
      if self.attributes.litTriggerTarget ~= "" and nameIndex.entities[self.attributes.litTriggerTarget] then
        for i, target in ipairs(nameIndex:getEntities(self.attributes.litTriggerTarget)) do
          if target.activate then
            target:activate(nil, -1)
          end
        end
      end
    end
  end
  
  
  --Return true if already unlit, return false if not
  return not oldLit
end



function Brazier:activate()
  player1.fire = true
end


function Brazier:update(dt)
  for i, fireball in ipairs(lightsFire) do
    
    if self.x - self.lightZoneWidth/2 < fireball.body:getX() and fireball.body:getX() < self.x + self.lightZoneWidth/2 and
      self.y - self.lightZoneHeight/2 < fireball.body:getY() and fireball.body:getY() < self.y + self.lightZoneHeight/2 then
      self:light()
    end
  end
 
 
  local frozen = false
  if self.attributes.extinguishTimer ~= 0 then
    
    frozen = effectedByTimeBubble(self)
    
    if not frozen then
      if self.extinguishTimer > 0 and self.extinguishTimer - dt < 0 then
        self:extingish()
      else
        self.extinguishTimer = math.max(0, self.extinguishTimer - dt)
      end
    end
  end
  
  if not frozen then
    self:updateAnimation(dt)
  end
end


function Brazier:draw()
  
  self:standardPropDraw()
  
  
  
  
  if debugMode or (self.selected and builderMode) then
    if self.attributes.interactRadius then
      love.graphics.setColor(1,0,0)
      blue.graphics.circle("line", self.x, self.y, self.attributes.interactRadius)
      
      love.graphics.setLineWidth("3")
      love.graphics.setColor(1,0.7,0)
      blue.graphics.rectangle("line", self.x - self.lightZoneWidth/2, self.y - self.lightZoneHeight/2, self.lightZoneWidth, self.lightZoneHeight)
      love.graphics.setLineWidth("1")
    end
  end
end