DirectionStone = Talkative:extend()

local particles = require "entities/directionStoneParticles"

function DirectionStone:new(x, y, attributes)
  DirectionStone.super.new(self, x, y, attributes)
  self.type = "directionStone"
  
  self.attributes.textureName = nil
  --createAttribute(self.attributes, "stoneActive", false)
  self.attributes.stoneActive = false
  self.nextParticle = 0
  self.internalTextureName = "direction_stone"
  self.interactPromptOffset = 50
  
  createAttribute(self.attributes, "targetX", 0)
  createAttribute(self.attributes, "targetY", 0)
  createAttribute(self.attributes, "particleLife", 8)
  
  self.attributes.animation = nil
  
  self.width  = texture.direction_stone:getWidth()  * smallTextureScale*math.abs(self.attributes.scaleX)
  self.height = texture.direction_stone:getHeight() * smallTextureScale*math.abs(self.attributes.scaleY)
  
end


function DirectionStone:activate(book)
  if not dialogueBox.displayed then
    self:playDialogue()
  end
  self:activateStone()
end



function DirectionStone:activateStone()
  if not self.attributes.stoneActive then
    self.attributes.stoneActive = true
    self.internalTextureName = "direction_stone_active"
    local sound = sound.effect.direction_stone_activate:clone()
    sound:play()
  end
end


function DirectionStone:updatePaused(dt)
  if self.attributes.stoneActive then
    self.internalTextureName = "direction_stone_active"
  else
    self.internalTextureName = "direction_stone"
  end
  
  if self.attributes.stoneActive then
    self.nextParticle = self.nextParticle - dt
    
    if self.nextParticle <= 0 then
      self.nextParticle = self.nextParticle + 0.05
      
      
      local targetPoint = Vec2(self.attributes.targetX, self.attributes.targetY)
      local offsetVector = Vec2(
        0 + (love.math.random()*2-1)*3,
        -33 + (love.math.random()*2-1)*3)
      local particleVector = targetPoint - self + offsetVector
      particleVector = vector.normalize(particleVector)
      DirectionParticle(self.x + offsetVector.x, self.y + offsetVector.y, particleVector, self.attributes.particleLife)
    end
  end
end







