Talkative = Interactable:extend()

local specialDialogue = require "entities/interactables/special dialogue"

function Talkative:new(x, y, attributes)
  Talkative.super.new(self, x, y, attributes)
  self.type = "talkative"
  self.isTalkative = true
  self.currentBook = 1
  createAttribute(self.attributes, "book1", "boop")
  createAttribute(self.attributes, "focusCamera", true)
end



function Talkative:activate(book)
  if not dialogueBox.displayed then
    self:playDialogue()
  end
end



function Talkative:playDialogue()

  if self.attributes.focusCamera then
    camera.targetPoint = Vec2((player1.body:getX() + self.x)/2, (player1.body:getY() + self.y)/2)
    camera.targetZoom = 5
  end

  if specialDialogue[self.attributes.name] then
    specialDialogue[self.attributes.name](self)
  else
    
    self:showBook(self.currentBook)
  end
  
end

function Talkative:showBook(number)
  dialogueBox:loadBook(self.attributes["book"..number])
end



function specialDialogue.linearRepeat(self)
  dialogueBox:loadBook(self.attributes["book"..self.currentBook])
  self.currentBook = self.currentBook + 1
  if self.attributes["book"..self.currentBook] == "" or self.attributes["book"..self.currentBook] == nil then
    self.currentBook = 1
  end
end
  
  
function specialDialogue.linearRepeatEnd(self)
  dialogueBox:loadBook(self.attributes["book"..self.currentBook])
  if not (self.attributes["book"..self.currentBook+1] == "" or self.attributes["book"..self.currentBook+1] == nil) then
    self.currentBook = self.currentBook + 1
  end
end


function specialDialogue.queueAllBooks(self)
  local books = {}
  for name, value in pairs(self.attributes) do
    if string.sub(name, 1, 4) == "book" and value ~= "" then
      books[tonumber(string.sub(name, 5, 5))] = value
    end
  end
  
  for i, value in ipairs(books) do
    dialogueBox:queueBook(value)
  end
end
  

  



    
    