--This is old code for a squeeze - I decided to keep it as a teleporter as I might find it useful

Squeeze = Object:extend()

function Squeeze:new(x, y, attributes)
  
  self.type = "squeeze"
  
  self.points = {Vec2(x, y)}
  
  
  self.attributes = attributes or {}
  
  createAttribute(self.attributes, "minSpeed", 10)
  createAttribute(self.attributes, "requiresFacing", true)
  createAttribute(self.attributes, "interactRadius", 100)
  
  
  table.insert(drawTable, self)
  
end




function Squeeze:addPoint(x, y, i)
  if i then
    table.insert(self.points, i, Vec2(x,y))
  else
    table.insert(self.points, Vec2(x,y))
  end
end


function Squeeze:interact(playerPosition)
  cout("YAY")
  
  self:startSqueeze()
  
end


function Squeeze:startSqueeze()
  local sideIsFirst
  do
    local playerPos = Vec2(player1.body:getPosition())
    local displacement1 = self.points[1] - playerPos
    local displacement2 = self.points[#self.points] - playerPos
    local distance1 = vector.getMagnitudeSqrd(displacement1) 
    local distance2 = vector.getMagnitudeSqrd(displacement2) 
    
    sideIsFirst = distance1 < distance2 
  end
  
  if sideIsFirst then
    player1.body:setPosition(self.points[#self.points].x, self.points[#self.points].y)
  else
    player1.body:setPosition(self.points[1].x, self.points[1].y)
  end
  
end



function Squeeze:removePoint(i)
  
  if i then
    table.remove(self.points, i, Vec2(x,y))
  else
    table.remove(self.points, #self.points, Vec2(x,y))
  end
  
end

local radius = 10

function Squeeze:checkSelect()
  
  local mousePos = Vec2(mouse.worldX, mouse.worldY)
  
  
  for i, point in ipairs(self.points) do
    if vector.getMagnitudeSqrd(mousePos - point) < radius^2 then
      return true
    end
  end
  return false
end


function Squeeze:isInteractable()
  
  return true
  
end


function Squeeze:delete()
  self.remove = true
end



function Squeeze:updateBuilder(dt)
  
  
  if not builder.selectedObject then
    if love.keyboard.isDown("delete") then
      if self:checkSelect() then
        
        self:delete()
        
      end
    end
  end
end


function Squeeze:drawOverlay()
  
  if self.selected then
    love.graphics.setColor(1,1,1)
    love.graphics.setLineWidth(5)
  else
    love.graphics.setColor(0.5,0.5,1)
    love.graphics.setLineWidth(2.5)
  end
  
  for i, point in ipairs(self.points) do
    if i ~= 1 then
      local lastPoint = self.points[i-1]
      blue.graphics.line(point.x, point.y, lastPoint.x, lastPoint.y)
    end
  end
  
  if self.finalised  then
    love.graphics.setColor(0,0,1)
  else
    love.graphics.setColor(1,0,1)
  end
  for i, point in ipairs(self.points) do
    blue.graphics.circle("line", point.x, point.y, radius)
  end
  love.graphics.setLineWidth(1)
  
  Prop.drawInteractPrompt(self)
end