local lightHandler = require "lighting/lightHandler"

function LevelPolygon:drawFinalised()
  love.graphics.setColor(1,1,1)



  local transparency

  if builderMode and self.attributes.fadeWhenBehind then
    if self:checkInside(mouse.worldX, mouse.worldY) then
      transparency = 1
    else
      transparency = 0.5
    end
  else
    transparency = self.currentTransparency
  end

  do
    local r, g, b = love.graphics.getColor()
    love.graphics.setColor(r, g, b, transparency)
  end
  --Reduce ambient light for backgrounds



  if self.attributes.isBackground then  
    love.graphics.setColor(0.7, 0.7, 0.7, 1-transparency)
  else
    love.graphics.setColor(1, 1, 1, 1-transparency)
  end

  blue.graphics.setZ(self.attributes.depth)

  if self.attributes.superTexture then
    shader.renderPasses:send("superTexture", true)
  end
  
  
  if not self.mesh then
    self:getPixpol(pixpol)
  end

  blue.graphics.drawShaded(self.mesh, self.body:getX(), self.body:getY(), self.body:getAngle())
  if self.attributes.superTexture then
    shader.renderPasses:send("superTexture", false)
  end



end




function LevelPolygon:getPixpol(pixpol)
  local offsetX, offsetY

  if self.attributes.isBackground then
    offsetX = 3
    offsetY = 1
  end

  if not pixpol then
    self.mesh = createPixpolMesh(texture[self.attributes.textureName], self.points, smallTextureScale, offsetX, offsetY)
    if not self.mesh then
      self.remove = true
    end
  else
    self.mesh = newTexturedMesh(texture[self.attributes.textureName], pixpol, smallTextureScale, offsetX, offsetY)
    if self.mesh then
      self.mesh:setDrawMode("triangles")
    else
      self.remove = true
    end
  end

end


