Projectile = Object:extend()

function Projectile:new(x, y, vx, vy)
  
  self.type = "projectile"
  vx = vx or 0
  vy = vy or 0
  
  self.body = love.physics.newBody(world, x, y, "dynamic")
  self.body:setLinearVelocity(vx, vy)
  self.body:setFixedRotation(true)
  self.shape = love.physics.newCircleShape(2)
  self.fixture = love.physics.newFixture(self.body, self.shape, 1)
  self.fixture:setCategory(2)
  self.fixture:setMask(2)
  
  Projectile.super.new(self)
  table.insert(drawTable, self)
end



function Projectile:draw()
  love.graphics.setColor(1, 0, 0)
  blue.graphics.circle("fill", self.body:getX(), self.body:getY(), self.shape:getRadius())
end