LightEmitter = Prop:extend()

function LightEmitter:new(x, y, attributes)
  LightEmitter.super.new(self, x, y, attributes)
  self.type = "lightEmitter"
  
  
  createAttribute(self.attributes, "lightOffsetX", 0)
  createAttribute(self.attributes, "lightOffsetY", 0)
  createAttribute(self.attributes, "lightZ", 0)
  createAttribute(self.attributes, "lightIntensity", 1)
  createAttribute(self.attributes, "lightFlicker", 0)
  createAttribute(self.attributes, "lightColour", "")
  
  
  self.flickerOffset = love.math.random()*1000
end



function LightEmitter:update(dt)
  self:updateAnimation(dt)
  
  
  if self.attributes.lightFlicker >= self.attributes.lightIntensity then
    cout("Light flicker was equal to or greater than 1! Setting to 0")
    self.attributes.lightFlicker = 0
  end
  

  
  
end



function LightEmitter:draw()
  
  local flickerAmount
  do
    local x = (love.timer.getTime() + self.flickerOffset)*10
    flickerAmount = (math.sin(x) + math.sin(4*x/9) + math.sin(x*2.2)*0.5 + math.sin(x*5.2)*0.25)*0.5*self.attributes.lightFlicker
  end
  
  
  --Maybe this could be optimised
  local hexCode = self.attributes.lightColour
  local colour
  
  if #hexCode == 6 then
    colour = {
      tonumber(hexCode:sub(1, 2),16)/255,
      tonumber(hexCode:sub(3, 4),16)/255, 
      tonumber(hexCode:sub(5, 6),16)/255}
    
  else
    colour = {1,1,1}
  end
  
  local offsetX = self.attributes.lightOffsetX * self.attributes.scaleX
  local offsetY = self.attributes.lightOffsetY * self.attributes.scaleY

  addLight(
    self.x + offsetX, 
    self.y + offsetY, 
    self.attributes.lightZ,
    self.attributes.lightIntensity + flickerAmount,
    colour
  )
  self:standardPropDraw()
end