RainEmitter = Prop:extend()

function RainEmitter:new(x, y, attributes)
  RainEmitter.super.new(self, x, y, attributes)
  self.type = "rainEmitter"
  
  self.texture = texture.icon_rain
  
  --Delete drawing stuff
  self.attributes.draw         = nil
  self.attributes.textureName  = nil
  self.attributes.animation    = nil
  self.attributes.priorityDraw = nil
  self.attributes.painted      = nil
  self.attributes.foreground   = nil
  self.attributes.rotation     = nil
  self.attributes.scaleX       = nil
  self.attributes.scaleY       = nil
  
  self.lastRained = 0
  
  createAttribute(self.attributes, "amount", 10)
  createAttribute(self.attributes, "spreadX", 100)
  createAttribute(self.attributes, "spreadY", 70)
  createAttribute(self.attributes, "initialVX", 0)
  createAttribute(self.attributes, "initialVY", 0)
  
  self.width  = self.texture:getWidth() * smallTextureScale
  self.height = self.texture:getHeight() * smallTextureScale

end


function RainEmitter:update(dt)
  if not effectedByTimeBubble(self) then
    while self.lastRained <= 0 do
      Raindrop(
        self.x + love.math.random(-self.attributes.spreadX/2, self.attributes.spreadX/2), 
        self.y + love.math.random(-self.attributes.spreadY/2, self.attributes.spreadY/2),
        nil,
        self.attributes.initialVX,
        self.attributes.initialVY
        )
      self.lastRained = self.lastRained + 1/self.attributes.amount
    end
    
    self.lastRained = self.lastRained - dt
  end
end




function RainEmitter:draw()
  
  
end


function RainEmitter:drawOverlay()
  
  
  if debugMode or builderMode then
    love.graphics.setColor(1,1,1, 0.5)
    blue.graphics.drawCentred(self.texture, self.x, self.y, 0, smallTextureScale, smallTextureScale)
  end
  
  
  if builderMode then
    if self.selected and builderMode then
      love.graphics.setColor(1, 1, 1)
      
      love.graphics.setLineWidth("3")
      blue.graphics.rectangle("line", self.x - self.width/2, self.y - self.height/2, self.width, self.height)
      love.graphics.setLineWidth("1")
    end
  end
  
  if debugMode or (self.selected and builderMode) then

    love.graphics.setColor(0,0.2,1)
    
    love.graphics.setLineWidth(2)
    if self.attributes.spreadX == 0 then
      blue.graphics.line(self.x, self.y - self.attributes.spreadY/2, self.x, self.y + self.attributes.spreadY/2)
    elseif self.attributes.spreadY == 0 then
      blue.graphics.line(self.x - self.attributes.spreadX/2, self.y, self.x + self.attributes.spreadX/2, self.y)
    else
      blue.graphics.rectangle("line", self.x - self.attributes.spreadX/2, self.y - self.attributes.spreadY/2, self.attributes.spreadX, self.attributes.spreadY)
    end
    love.graphics.setLineWidth(1)
  end
end