line = {}

function line.getClosestPoint(ax, ay, bx, by, px, py)
  
  local a = Vec2(ax, ay)
  local b = Vec2(bx, by)
  local p = Vec2(px, py)
  
  local ab = b - a
  local ap = p - a
  
  local proj = vector.dotProduct(ap, ab)
  
  local abLenSqrd = vector.getMagnitudeSqrd(ab)
  
  local d = proj / abLenSqrd
  
  if d <= 0 then
    return Vec2(ax, ay)
  elseif d >= 1 then
    return Vec2(bx, by)
  else
    return a + (ab * d)
  end

end


function line.infiniteIntersection(x1, y1, x2, y2, x3, y3, x4, y4)
  -- from https://dirask.com/posts/JavaScript-calculate-intersection-point-of-two-lines-for-given-4-points-VjvnAj
  
  
  local denomonator = (x1 - x2)*(y3 - y4) - (y1 - y2)*(x3 - x4)
  
  local x = 
  ((x1*y2 - y1*x2)*(x3 - x4) - (x1 - x2)*(x3*y4 - y3*x4))
  /denomonator
  
  local y = 
  ((x1*y2 - y1*x2)*(y3 - y4) - (y1 - y2)*(x3*y4 - y3*x4))
  /denomonator
  
  
  return x, y
end


