Menu = Object:extend()

 
function MenuElement(name, inputFunction)
  local newElement = {}
  
  newElement.name = name
  newElement.buttonFunction = inputFunction
  
  function newElement:enter()
    self.buttonFunction()
  end
  
  return newElement
end




pauseMenu = Menu("pauseMenu", {"Resume", "Settings", "Quit"})


function Menu:new(name, elements)
  
  
  self.name = name
  self.elements = elements
  self.index = 1
  self.shown = false
  
end


function Menu:show()
  
  self.shown = true
  self.index = 1
  
end


function Menu:hide()
  
  self.shown = false
  
end  

function Menu:enter()
  
  self.elements[self.index]:enter()
  
end


function Menu:up()
  
  self.index = self.index - 1
  
  if self.index < 1 then
    self.index = #self.elements
  end
  
end


function Menu:down()
  
  self.index = self.index + 1
  
  if self.index > #self.elements then
    self.index = 1
  end
  
end


function Menu:draw()
  
  local menuWidth = 200
  local menuHeight = 200
  
  
  local menuX = window.width/2 - menuWidth/2
  local menuY = window.height/2 - menuHeight/2
  
  love.graphics.setColor(0.3, 0.3, 0.3)
  love.graphics.rectangle("fill", menuX, menuY, menuWidth, menuHeight)
  
  
  local textScale = 1
  
  local elementHeight = font:getHeight()*textScale + 2

  
  
  for i, element in ipairs(self.elements) do
    
    if i == self.index then
      love.graphics.setColor(0,1,1)
    else
      love.graphics.setColor(1,1,1)
    end
    
    local x = 0
    local y = elementHeight * (i-1)
    
    love.graphics.print(element.name, x + menuX, y + menuY, 0, textScale)
    
    
  end
  
  
end