shader = {}
  
--local previousShaderSettings -- For future use - might be redundant given how fast these shaders compile, but it might be worth when updating shader settings to only reload shaders which's settings have changed


local function releaseShaders()
  
  for i, v in pairs(shader) do
    if not v:release() then
      cout("Warning - Tried to release shader ("..i..") that does not exist.")
    end
  end
  
end
  
  
function reloadShaders(shaderSettings)
  releaseShaders()
  loadShaders(shaderSettings)
end
  
  
function loadShaders(shaderSettings)
    
  shader.timeBubble = love.graphics.newShader("shaders/timeBubble.glsl")
  
  shader.lambertLighting = love.graphics.newShader("shaders/lambertLighting.glsl")
  
  shader.renderPasses = love.graphics.newShader("shaders/renderPasses.glsl")
  
  shader.blurX = love.graphics.newShader("shaders/blurX.glsl")
  shader.blurY = love.graphics.newShader("shaders/blurY.glsl")
  
end
    
    
    
return shader