function reloadTextures()
  texture = {}

  texture.metatable = {}
  setmetatable(texture, texture.metatable)
  function texture.metatable.__index (table, key)
    return texture.placeholder
  end

  animation = {}

  animation.metatable = {}
  setmetatable(animation, animation.metatable)
  function animation.metatable.__index (table, key)
    --Don't have a placeholder animation yet
    return animation.drea_running
  end

  texture.keypress       = love.graphics.newImage("textures/misc/keypress.png")

  texture.cloudSheet     = love.graphics.newImage("textures/environment/cloud sheet.png")
  texture.stone          = love.graphics.newImage("textures/environment/stone.png")
  texture.water          = love.graphics.newImage("textures/environment/water.png")
  texture.moss          = love.graphics.newImage("textures/environment/moss.png")
  texture.wood           = love.graphics.newImage("textures/environment/wood.png")
  texture.bricks         = love.graphics.newImage("textures/environment/bricks.png")
  texture.vertical_wood  = love.graphics.newImage("textures/environment/vertical wood.png")
  texture.skyStone       = love.graphics.newImage("textures/environment/sky stone.png")
  texture.grass = {}
  texture.grass[1]       = textureSet("environment/grass/grass1")
  texture.grass[2]       = textureSet("environment/grass/grass2")
  texture.grass[3]       = textureSet("environment/grass/grass3")
  texture.grassFlower = {}
  texture.grassFlower[1] = textureSet("environment/grass/grass1flower")
  texture.grassFlower[2] = textureSet("environment/grass/grass2flower")
  texture.grassFlower[3] = textureSet("environment/grass/grass3flower")
  texture.stoneBox       = textureSet("objects/stoneBox")
  
  texture.vine =      textureSet("plants/droop vine")
  texture.long_vine = textureSet("plants/long vine")
  texture.fork_vine = textureSet("plants/fork long vine")
  texture.short_vine = textureSet("plants/short droop vine")

  texture.logic_prop           = love.graphics.newImage("textures/icons/icon_logic.png")

  texture.grappling_hook   = textureSet("objects/grapplingHook")
  texture.backpack         = textureSet("objects/backpack")
  texture.rope_coil        = textureSet("objects/rope coil")
  texture.red_rope         = love.graphics.newImage("textures/environment/red rope.png")
  texture.stove            = textureSet("objects/stove")


  texture.kettle           = textureSet("objects/kettle")
  texture.barrel           = textureSet("objects/barrel")
  texture.table            = textureSet("objects/table")
  texture.chair            = textureSet("objects/chair")
  texture.pot              = textureSet("objects/pot")
  texture.light_wall       = textureSet("objects/light wall")
  texture.sign             = textureSet("objects/sign")
  texture.bookshelf        = textureSet("objects/bookshelf")
  texture.mug              = textureSet("objects/mug")
  texture.big_plant        = textureSet("objects/big plant")
  texture.blossom_painting = textureSet("objects/blossom painting")
  texture.brazier          = textureSet("objects/brazier")
  texture.brazier_lit      = love.graphics.newImage("textures/objects/brazier lit/brazier lit13.png")
  texture.direction_stone        = textureSet("objects/direction stone")
  texture.direction_stone_active = textureSet("objects/direction stone active")

  texture.icon_stone           = textureSet("icons/icon_stone")
  texture.icon_backgroundStone = textureSet("icons/icon_backgroundStone")
  texture.icon_wood            = textureSet("icons/icon_wood")
  texture.icon_backgroundWood  = textureSet("icons/icon_backgroundWood")
  texture.icon_prop            = textureSet("icons/icon_prop")
  texture.icon_talkative       = textureSet("icons/icon_talkative")
  texture.icon_rain            = textureSet("icons/icon_rain")

  texture.start_menu_background = love.graphics.newImage("textures/backgrounds/start menu.png")



  texture.doors = {}
  texture.doors.metatable = {}
  setmetatable(texture.doors, texture.doors.metatable)
  function texture.doors.metatable.__index (table, key)
    return texture.doors.wooden
  end


  texture.doors.wooden = doorTextureSet("wooden", -18)

  texture.volt_mural_1 = textureSet("objects/murals/volt mural 1")
  texture.volt_mural_2 = textureSet("objects/murals/volt mural 2")
  texture.volt_mural_3 = textureSet("objects/murals/volt mural 3")
  texture.volt_mural_4 = textureSet("objects/murals/volt mural 4")


  texture.test_grom     = textureSet("test/grom_boop")
  texture.placeholder   = textureSet("placeholder")

  texture.drea_idle     = textureSet("drea/Idle", 15.5)
  texture.drea_tucked   = textureSet("drea/Tucked")
  texture.drea_sleeping = textureSet("drea/Sleeping")
  texture.drea_falling  = textureSet("drea/Falling")
  texture.drea_sliding  = textureSet("drea/Sliding/Sliding", 16.5)

  texture.firefly      = love.graphics.newImage("textures/misc/Firefly.png")
  texture.firefly_body = love.graphics.newImage("textures/misc/Firefly Body.png")

  texture.magic_decay        = love.graphics.newImage("textures/effects/magic decay.png")
  texture.fireball           = love.graphics.newImage("textures/objects/fireball.png")
  texture.spark              = love.graphics.newImage("textures/effects/spark.png")
  texture.raindrop           = love.graphics.newImage("textures/effects/raindrop.png")
  texture.direction_particle = love.graphics.newImage("textures/effects/direction particle.png")


  animation.drea = {}
  animation.drea_running  = Animation("drea/Running",  13, 11, 0)
  animation.drea_flapping = Animation("drea/Flapping", 12, 4, -6)
  animation.drea_gliding  = Animation("drea/Gliding",  5, 4, 2)

  animation.effect = {}
  animation.effect_magicRipple = Animation("effects/magic ripple", 18)

  animation.kettle_steam = Animation("objects/kettle steam", 10)
  animation.brazier_lit = Animation("objects/brazier lit", 13, 0, 0)


  texture.voltehre_idle = textureSet("voltehre/idle")
  texture.cordelia_idle = textureSet("cordelia/idle")
  texture.curator_idle  = textureSet("curator/idle")

end



function textureSet(filename, xOffset, yOffset, useNormalMap)
  local textureSet = {}

  textureSet.ox = xOffset or 0
  textureSet.oy = yOffset or 0
  
  useNormalMap = useNormalMap or true


  textureSet.main = love.graphics.newImage("textures/"..filename..".png")
  if file_exists("textures/"..filename.." Shadow.png") then
    textureSet.shadow = love.graphics.newImage("textures/"..filename.." Shadow.png")
  end
  
  --For some reason canvases don't work properly on AMD cards in shaders, so they're being generated and saved automatically
  if useNormalMap then
    
    local normalPath = "normals/"..filename..".png"
    
    if not file_exists(normalPath) then
      
      print(normalPath.. " was not found, so it was generated automatically.")
      
      local fileFolder = string.sub(normalPath, 1, string.find(normalPath, "/[^/]*$"))
      
      
      local normalCanvas = newNormalMap("textures/"..filename..".png")
      
      love.filesystem.createDirectory( fileFolder )
      normalCanvas:newImageData():encode("png", normalPath)
      
    end
    
    
    textureSet.normalMap = love.graphics.newImage(normalPath)
  end
  
  
  
  
  if file_exists("textures/"..filename.." Glow.png") then
    textureSet.glow = love.graphics.newImage("textures/"..filename.." Glow.png")
  end
  
  --Defining texture set functions for convenience
  function textureSet:getWidth()
    return textureSet.main:getWidth()
  end
  
  function textureSet:getHeight()
    return textureSet.main:getHeight()
  end
  
  
  return textureSet
end


function doorTextureSet(name, xOpenOffset)
  local set = {}

  set.ox = xOpenOffset or 0

  set.open   = textureSet("objects/doors/"..name.." door open")
  set.closed = textureSet("objects/doors/"..name.." door closed")

  return set
end


reloadTextures()