function beginContact(a, b, coll)
  if a:getUserData() == "sensor" or b:getUserData() == "sensor" then
    groundSensor.triggered = true
  end
end

function endContact(a, b, coll)
  player1.collisionTable[a] = nil
  player1.collisionTable[b] = nil
end


function preSolve(a, b, coll)
  
  if a:getUserData() == "player" or b:getUserData() == "player" then
    
    --fuuuuuuuck i'm gonna need to calculate the normal inpulse  myself
    
    local normal = Vec2(coll:getNormal())
    
    local aVel = Vec2(a:getBody():getLinearVelocity())
    local bVel = Vec2(b:getBody():getLinearVelocity())
    
    local relativeVelocity = bVel - aVel
    
    local normalVelocity = vector.project(relativeVelocity, normal)
    
    local playerMass
    
      if a:getUserData() == "player" then
        playerMass = a:getBody():getMass()
      else
        playerMass = b:getBody():getMass()
      end
    
    local restitution = math.max(a:getRestitution(), b:getRestitution())
    
    
    
    local vel = vector.getMagnitude(normalVelocity)
    
    
    --For some reason the real collision impulse is consistently 1.25* higher than my own value, but never precisely. Unsure what I'm missing here
    
    local impulse = math.abs(vel * coll:getRestitution()) * 1.25
    
    
    if impulse >= 200 and (not player1.tucked) and (not (player1.bonkImmunity > 0)) then
      player1.body:setFixedRotation(false)
      player1.bonked = 1.5
    end

    
  end
end


function postSolve(a, b, coll, normalimpulse, tangentimpulse)
 
	if a:getUserData() == "player" or b:getUserData() == "player" then
    
    if (normalimpulse > 80 and player1.parried <= 0) or normalimpulse > 400 then
      sound.effect.thud:setVolume((normalimpulse-60)/200)
      sound.effect.thud:play()
    end
    
    local notPlayer
    local player
    
    if a:getUserData() == "player" then
      notPlayer = b
      player = a
    else
      notPlayer = a
      player = b
    end
    player1.collisionImpulse = normalimpulse
    
    
    local nx, ny = coll:getNormal( )
  
    local normalVector = Vec2(nx, ny)
    table.insert(player1.collisionTable, normalVector)
      

  elseif (a:getUserData() and a:getUserData().type == "sword") or (b:getUserData() and b:getUserData().type == "sword") then
    local sword = nil
    if (a:getUserData() and a:getUserData().type == "sword") then
      sword = a:getUserData()
      if not sword.locked then
        sword.lockedBody = b:getBody()
      end
    end
    if (b:getUserData() and b:getUserData().type == "sword") then
      sword = b:getUserData()
      if not sword.locked then
        sword.lockedBody = a:getBody()
      end
    end

    sword.locked = true
    
    
  elseif (a:getUserData() and a:getUserData().type == "fireball")  then
    a:getUserData().collided = true
  elseif (b:getUserData() and b:getUserData().type == "fireball") then
    b:getUserData().collided = true
  end
  
  --[[if a:getUserData() and a:getUserData().storeSlowmoValues then
    
    print(a:getUserData().storeSlowmoValues)
    a:getUserData():storeSlowmoValues()
  end
  
  if b:getUserData() and b:getUserData().storeSlowmoValues then
    b:getUserData():storeSlowmoValues()
  end]]
  
end


function Player:getCollisionVectors()
  
  local numberOfEntries = 0
  for i, v in ipairs(player1.collisionTable) do
    numberOfEntries = numberOfEntries + 1
  end
  if numberOfEntries > 0 then
    self.contactWithGround = true
  else
    self.contactWithGround = false
    return
  end
  local trueAverageNormal = Vec2(0,0)
  local averageNormal = Vec2(0,0)
  local averageVelocity = Vec2(0, 0)
  for i, v in pairs(self.collisionTable) do
    trueAverageNormal = averageNormal + v
    --Check to see if the surfaces are valid for walking on
    if self:canWalkPart(v) then
      averageNormal = averageNormal + v
    end
  end
  trueAverageNormal = vector.normalize(trueAverageNormal)
  averageNormal = vector.normalize(averageNormal)
  
  self.tangentWithGround = vector.turn90Degrees(vector.normalize(averageNormal))
  local relativeVelocity = self.velocityLastFrame - averageNormal
  self.tangentVelocity = vector.project(relativeVelocity, player1.tangentWithGround)
  self.walkableNormalVelocity = vector.project(relativeVelocity, averageNormal)
  self.normalVelocity = vector.project(relativeVelocity, trueAverageNormal)
  self.trueNormalWithGround = trueAverageNormal 
  self.normalWithGround = averageNormal
  
end


function Player:clearCollisionTable()
  
  self.collisionTable = {}
end


