local nameIndex = {}

--Manages refering to other entities by name

nameIndex.entities = {}

function nameIndex:addEntity(entity, newName)
  --Requires only the entity to be passed, the name can be found

  local name = newName or entity.attributes.name

  if name then
    if not self.entities[name] then
      self.entities[name] = {entity}

    else
      table.insert(self.entities[name], entity)
    end
  else
    cout("Entity has no name!")
  end
end


function nameIndex:removeEntity(entity, oldName)
  --Requires only the entity to be passed, the name can be found

  local name = oldName or entity.attributes.name

  if self.entities[name] then
    if #self.entities[name] == 1 then
      --Delete this entry if its the only one
      self.entities[name] = nil
    else
      local index = nil
      for i, v in ipairs(self.entities[name]) do
        if v == self.entities[name] then
          index = i
          break
        end
      end

      table.remove(self.entities[name], index)
    end
  else
    error("Something has gone very wrong, named entry '"..name.."' does not exist!")
  end
end

function nameIndex:updateEntityName(entity, newName)

  if newName then
    self:addEntity(entity, newName)
  end

  if entity.attributes.name ~= "" then
    self:removeEntity(entity)
  end
end


function nameIndex:getEntities(name)
  
  if name ~= "" and self.entities[name] then
    return nameIndex.entities[name]
  else
    return {}
  end
  
end


return nameIndex