extern Image MainTex;
extern float depthValue;
extern Image normalMap;
extern bool hasNormalMap;
extern float rotation;
extern bool flipX;
extern bool flipY;
extern bool superTexture;

#define COLOUR_CANVAS love_Canvases[0]
#define DEPTH_CANVAS love_Canvases[1]
#define NORMAL_CANVAS love_Canvases[2]

void effect()
{
  vec4 pixel = Texel(MainTex, VaryingTexCoord.xy)*VaryingColor;

  if (pixel.a == 0.0)
  {
    discard;
    return;
  }
  
  // This is to make the rock look funky
  if (superTexture)
  {
    vec4 farPixel = Texel(MainTex, VaryingTexCoord.xy/16.0 )*VaryingColor;
    pixel = pixel + (farPixel - pixel)*0.3;
  }
  
  
  
  COLOUR_CANVAS = pixel;
  DEPTH_CANVAS =  vec4(depthValue, depthValue, depthValue, 1.0);
  
  if (hasNormalMap)
  {
    vec4 normal = Texel(normalMap, VaryingTexCoord.xy);
    
    //Convert to proper vector form
    
    normal.x = (normal.x-0.5)*2.0;
    normal.y = (normal.y-0.5)*2.0;
    normal.z = (normal.z-0.5)*2.0;
    
    if (flipX) normal.x *= -1.0;
    if (flipY) normal.y *= -1.0;
    
    //Rotate normal
    
    float cosA = cos(rotation);
    float sinA = sin(rotation);
    float x1 = normal.x;
    float y1 = normal.y;
    
    normal.x = cosA*x1 - sinA*y1;
    normal.y = sinA*x1 + cosA*y1;
    
    //Convert back to colour
    normal.x = normal.x * 0.5 + 0.5;
    normal.y = normal.y * 0.5 + 0.5;
    normal.z = normal.z * 0.5 + 0.5;
    
    NORMAL_CANVAS = normal;
  }
  else
  {
    NORMAL_CANVAS = vec4(0.5,0.5,1.0,pixel.a);
  }
}
  
  
