local startMenu = {}
local widthScale
local heightScale
local quad = love.graphics.newQuad( 0, 0, love.graphics.getWidth(), love.graphics.getHeight(), 1, 1 )
local fade = 1


--Note to self - code here is VERY messy - there is a self.fading and a local fade variable. This needs to be fixed if this ever gets reworked





function startMenu:make()
  startMenu.buttons = {}
  StartMenuButton(1500, 800, 2, false)
end



function startMenu:showMenu()
  sound.music.tranquility:setVolume(1)
  sound.music.tranquility:play()
  fade = 1
  self.fading = nil
end


function startMenu:closeMenu()
  onStartMenu = false
  sound.music.tranquility:stop()
  
end



function startMenu:checkButtonSelect()
  
  local newButton = false
  
  for i, button in ipairs(self.buttons) do
    
    if button.active then
      local x, y  = button:getPosition()
      
      local mx, my = love.mouse.getPosition()
      local checkRedius = button:getRadius()
      
      if (x - mx)^2 + (y - my)^2 <= checkRedius^2 then
        button.selected = true
      else
        button.selected = false
      end
    end
  end

end


function startMenu:update(dt)
  widthScale  = window.width/1920
  heightScale = window.height/1080
  

  fade = math.max(fade - dt/3, 0)
  self:checkButtonSelect()
  
  for i, button in ipairs(self.buttons) do
    button:update(dt)
  end
  
  
  if controls.interact.thisFrame then
    for i, button in ipairs(self.buttons) do
      button:onClick(self)
    end
  end
  
  
  
  if clickedThisFrame.primary then
    for i, button in ipairs(self.buttons) do
      if button:click(self) then
        break
      end
    end
  end
  
  if self.fading then
    self.fading = self.fading + dt/2
    
    
    sound.music.tranquility:setVolume(math.max(1-self.fading, 0))


    if self.fading >= 1.5 then
      startGame()
      self:closeMenu()
    end
  end


end


function startMenu:fadeOut()
  self.fading = 0
end


local function drawCloudSheet(x, y)
  quad:setViewport(-x, -y, window.width, window.height, texture.cloudSheet:getWidth()*16, texture.cloudSheet:getHeight()*16)
  love.graphics.draw(texture.cloudSheet, quad, 0, 0)
end


function startMenu:draw()
  
  if fade ~= 1 then
    
    love.graphics.setBackgroundColor(132/255, 173/255, 1)
    local background = texture.start_menu_background
    local scale = 0.7*heightScale
    
    local t = love.timer.getTime()+50
    
    love.graphics.setColor(1,1,1, 0.5)
    drawCloudSheet(t*25, t*5)
    love.graphics.setColor(1,1,1, 0.25)
    drawCloudSheet(t*50, window.height/2)
    

    local heightOffset = (math.sin(love.timer.getTime()) -1)*5*scale
    love.graphics.setColor(1,1,1)
    
    love.graphics.draw(background, 0, 0+heightOffset, 0, scale, scale)
    
    
    --print(#self.buttons)
    
    
    for i, button in ipairs(self.buttons) do
      button:draw()
    end
    

  end
  
  
  
  
    --Draw mouse

  local mx, my = love.mouse.getPosition()

  love.graphics.setColor(1,1,1)
  love.graphics.circle("fill", mx, my, 5)
  love.graphics.setColor(0,0,0)
  love.graphics.circle("line", mx, my, 5)
  
  

  love.graphics.setColor(0,0,0, fade + (self.fading or 0))
  love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
  --Not sure why I needed to add extra pixels, but there was a line at the top of the screen for some reason
  --love.graphics.rectangle("fill", -1, -1, love.graphics.getWidth()+2, love.graphics.getHeight()+2)
  
  
  
end


return startMenu