TextEditor = Object:extend()


function TextEditor:new()
  TextEditor.type = "textEditor"
  
  self.active = false
  self.value = nil
  self.width = window.width*0.5
  self.height = window.height*0.5
  self.callback = nil
  self.cursorPos = 1

  self.x = window.width/2 - self.width/2
  self.y = window.height/2 - self.height/2
end


function TextEditor:setPos(x, y)
  self.x = x
  self.y = y
end


function TextEditor:addCursor(text)
  

  return string.sub(text, 1, self.cursorPos)..'|'.. string.sub(text, self.cursorPos+1, #text)
  
  
end


function TextEditor:draw()
  
  if self.active then
    love.graphics.setColor(0.3, 0.3, 0.3)
    love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)
    love.graphics.setColor(0.2, 0.2, 0.2)
    love.graphics.rectangle("line", self.x, self.y, self.width, self.height)
    love.graphics.setColor(1, 1, 1)
    local scale = 3
    love.graphics.printf(self:addCursor(self.value), self.x, self.y, self.width/scale , nil, nil, scale, scale)
  end
end


function TextEditor:finish()
  self.callback()
  self:close()
end


function TextEditor:show(default)
  self.active = true
  if type(default) == "number" then
    self.value = tostring(default)
  else
    self.value = default
  end
  self.cursorPos = #self.value
end


function TextEditor:close()
  self.active = false
end


function love.textinput(text)
  if textEditor.active then
    
    if textEditor.cursorPos < 0 then
      textEditor.cursorPos = 0
    end
    
    textEditor.value = string.sub(textEditor.value, 1, textEditor.cursorPos)..text.. string.sub(textEditor.value, textEditor.cursorPos+1, #textEditor.value)
    textEditor.cursorPos = textEditor.cursorPos + 1
    
  end
end


