--https://stackoverflow.com/questions/4990990/check-if-a-file-exists-with-lua
function file_exists(name)
  return love.filesystem.getInfo(name)
end


function snapTo(x, n)
  return math.floor((x/n)+0.5)*n
end


function convertToTable(...)
    local returnTable = {}
    local args = {...}
    for i, v in ipairs(args) do 
        returnTable[i] = v
    end
    return returnTable
end


function printTable(table)
  for i, v in pairs(table) do
    print("["..i.."]\t"..tostring(v))
  end
end


function copyTable(srcTable)
  local newTable = {}
  for i, v in pairs(srcTable) do
    newTable[i] = v
  end
  return newTable
end


function math.ulerp(a, b, t)
  return (b-a)*t + a
end



--Easy toggle function
function toggle(var, option1, option2)
    if var == option1 then
      return option2
    else
      return option1
    end
end

function swapKeyValues(table)
  local newTable = {}
  for i, v in ipairs(table) do
    newTable[v] = i
  end
  return newTable
end



function lockToPixels(x, y, mode, offsetModeX, offsetModeY)
  
  mode = mode or "small"
  
  local offsetX = 0
  local offsetY = 0
  
  if offsetModeX then
    offsetX = 0.5
  end
  if offsetModeY then
    offsetY = 0.5
  end
  
  if not love.keyboard.isScancodeDown("lshift") then
    if mode == "small" then
      return (math.floor(x/smallTextureScale+0.5-offsetX) + offsetX)*smallTextureScale, (math.floor(y/smallTextureScale+0.5-offsetY) + offsetY)*smallTextureScale
    else 
      return (math.floor(x/textureScale+0.5-offsetX) + offsetX)*textureScale, (math.floor(y/textureScale+0.5-offsetY) + offsetY)*textureScale
    end
  else
    return x, y
  end
end


function createAttribute(source, name, value)
  
  if source[name] == nil or (type(source[name]) == "string" and string.lower(source[name]) == "not implemented") then
    source[name] = value
  end
end


function removeAttribute(source, name)
  
  if source[name] ~= nil then
    source[name] = nil
  end
end
  
  
function getPolygonArea(polygon)
--Returns the signed area of a polygon
  local area = 0
  for i = 1, #polygon, 2 do

    local x1, y1
    local x2 = polygon[i]
    local y2 = polygon[i+1]
    
    if i == 1 then
      x1 = polygon[#polygon-1]
      y1 = polygon[#polygon]
    else
      x1 = polygon[i-2]
      y1 = polygon[i-1]
    end

    area = area + (x1*y2 - y1*x2)
  end
    
  area = area/2
  
  return area
end
